#include <unistd.h>
#include <fcntl.h>
#include <sys/kd.h>
#include <gpm.h>

#define P printf

#define DELAY 200

int long_down = 0;

#define POLLING_TIME 100000

#define FREQUENCY 256
#define DURATION 16

#include "afe_mouse_actions.c"

int console_fd;

Gpm_Event event;

mev_handler ()
{

  if (long_down)
    {
      long_down = 0;
      return;
    }

  if (Gpm_Repeat (DELAY))
    {

      if ((event.type == (GPM_UP | GPM_SINGLE)))
	{
	  if (event.buttons == GPM_B_LEFT)
	    {
	      left_1 ();
	      return;
	    }
	  if (event.buttons == GPM_B_MIDDLE)
	    {
	      middle_1 ();
	      return;
	    }
	  if (event.buttons == GPM_B_RIGHT)
	    {
	      right_1 ();
	      return;
	    }
	}

      if ((event.type == (GPM_UP | GPM_DOUBLE)))
	{
	  if (event.buttons == GPM_B_LEFT)
	    {
	      left_2 ();
	      return;
	    }
	  if (event.buttons == GPM_B_MIDDLE)
	    {
	      middle_2 ();
	      return;
	    }
	  if (event.buttons == GPM_B_RIGHT)
	    {
	      right_2 ();
	      return;
	    }
	}

      if ((event.type == (GPM_DOWN | GPM_SINGLE)))
	{
	  if (event.buttons == GPM_B_LEFT)
	    {
	      left_long ();
	      return;
	    }
	  if (event.buttons == GPM_B_MIDDLE)
	    {
	      middle_long ();
	      return;
	    }
	  if (event.buttons == GPM_B_RIGHT)
	    {
	      right_long ();
	      return;
	    }
	}

    }

}

main (int ac, char **av)
{
  int i;
  Gpm_Connect conn;

  if (ac == 1)
    {
      fprintf (stderr, "Usage: %s <filename> [<afe commands>] ...\n", av[0]);
      exit (1);
    }

  /* build a catch-all connectionData */
  conn.eventMask = ~0;
  conn.defaultMask = 0;
  conn.maxMod = ~0;
  conn.minMod = 0;

  if (Gpm_Open (&conn, -1) == -1)
    {
      perror ("Gpm_Open");
      exit (1);
    }

  console_fd = open ("/dev/console", O_WRONLY);

  setbuf (stdout, NULL);

  P ("\"%s\"dst", av[1]);
  for (i = 2; i < ac; i++)
    P ("%s", av[i]);

  while (1)
    {
      Gpm_GetEvent (&event);
      mev_handler ();
    }
  Gpm_Close ();
  exit (0);
}

back ()
{
  P ("<");
}

play_last_second ()
{
  P ("P");
}

forth ()
{
  P (">");
}

goto_start ()
{
  P ("^");
}

play ()
{
  P ("c");
  while (Gpm_GetSnapshot (&event) != 0)
    usleep (POLLING_TIME);
  P (" ");
}

goto_end ()
{
  P ("$");
}

fast_backward ()
{
  P ("500t");
  while (Gpm_GetSnapshot (&event) != 0)
    {
      P ("<");
      click ();
      usleep (POLLING_TIME);
    }
  P ("50t");
  play_last_second ();
}

record ()
{
  click ();
  P ("R\n");
  while (Gpm_GetSnapshot (&event) != 0)
    usleep (POLLING_TIME);
  P (" ");
  click ();
}

fast_forward ()
{
  P ("500t");
  while (Gpm_GetSnapshot (&event) != 0)
    {
      P (">");
      click ();
      usleep (POLLING_TIME);
    }
  P ("50t");
  play_last_second ();
}

click ()
{
  ioctl (console_fd, KDMKTONE, FREQUENCY + (0x10000 * DURATION));
}
